caylus = {
	state_mt = {},
	building_mt = {},
	}
caylus.state_mt.__index = caylus.state_mt
caylus.building_mt.__index = caylus.building_mt

--values for state.phase, and returned by current_phase()
PHASE_WORKER_PLACEMENT = 1
PHASE_ACTIVATE_BUILDINGS = 2
PHASE_CASTLE_FAVOR = 3
PHASE_SCORING = 4
PHASE_END = 5
--used only by UI
PHASE_MOVE_PROVOST = 11
PHASE_PICKUP_PROFIT = 12
PHASE_FAVOR = 13
PHASE_SELECT_BUILDING = 14
PHASE_CASTLE_BUILD = 15
PHASE_GATE = 16

--special values for state.turn
TURN_OWNER_ACTION = 10
TURN_BOARD_ACTION = 11

--positions of fixed buildings
GATE_POSITION = 1
TRADING_POST_POSITION = 2
MERCHANT_GUILD_POSITION = 3
JOUST_POSITION = 4
STABLES_POSITION = 5
INN_POSITION = 6
BRIDGE_POSITION = 7
BAILIFF_START_POSITION = 13
GOLDMINE_POSITION = 23
CASTLE_POSITION = 36
FIRST_EMPTY_POSITION = 16
LAST_EMPTY_POSITION = 35

--indicates when a scoring round is triggered
CASTLE_CONTRIBUTION_THRESHOLDS = { 6, 16, 30 }
CASTLE_BAILIFF_THRESHOLDS = { 19, 25, 31 }

--penalties for having no contributes at scoring time
NO_CONTRIBUTION_PENALTY = { 2, 3, 4 }

PLAYERS_INFO = {
		{ name = "Andres", color = "green" },
		{ name = "Babette", color = "blue" },
		{ name = "Cherie", color = "red" },
		{ name = "Denis", color = "brown" },
		{ name = "Emile", color = "yellow" },
		}
GATE = { name = "Gate", description = "A worker here moves to another location of its master's choice.", id = "gate" }
TRADING_POST = {
	name = "Trading post", id = "trading-post",
	description = "Gives 3 deniers.",
	actions = { "take 3$" } }
MERCHANT_GUILD = { name = "Merchant guild", description = "Move the provost up to 3 spaces for free.", id = "merchant-guild" }
JOUST_FIELD = { name = "Joust field", description = "Turn in one cloth and one denier and receive a favor.", id = "joust" }
STABLES = { name = "Stables", description = "Take a more favorable spot in turn order", worker_limit = 3, id = "stables" }
INN = { name = "Inn", description = "Worker stays in the inn next turn. Its master can place workers for 1 denier anywhere, even when others have passed.", id = "inn" }
BRIDGE = { name = "Bridge", worker_limit = 0, id = "bridge" }
GOLD_MINE = {
	name = "Gold mine", id = "goldmine",
	description = "Gives one gold.",
	actions = { "take 1g" }  }
CARPENTER1 = {
	name = "Carpenter", id = "neutral-carpenter",
	description = "Allows construction of wooden buildings.",
	is_builder = true, builder_type = "wood",
	tile_id = 1 }
CARPENTER2 = {
	name = "Carpenter", id = "fixed-carpenter",
	description = "Allows construction of wooden buildings.",
	is_builder = true, builder_type = "wood"
	}
PEDDLER1 = { name = "Peddler", description = "Buy a resource cube from the bank for 2 deniers.", id = "fixed-peddler" }
PEDDLER2 = { name = "Peddler", description = "Buy up to two resource cubes from the bank for 1 denier each.", id = "wood-peddler", btype = "wood", cost = "1w,1_", reward = "4vp", tile_id = 11 }
MARKETPLACE1 = { name = "Marketplace", description = "Sell a resource cube for 4 deniers.", id = "neutral-market", tile_id = 5 }
MARKETPLACE2 = { name = "Marketplace", description = "Sell a resource cube for 6 deniers.", id = "wood-market", btype = "wood", cost = "1w,1_", reward = "4vp", tile_id = 9 }
CASTLE = { name = "Castle", description = "Contribute a set of three resources (one must be food) to the castle.", worker_limit = 5, id = "castle" }
MASON = {
	name = "Mason", id = "mason",
	description = "Constructs stone buildings",
	btype = "wood", cost = "1w,1f", reward = "4vp",
	is_builder = true, builder_type = "stone",
	tile_id = 7 }
LAWYER = {
	name = "Lawyer", id = "lawyer",
	description = "Converts buildings to residences",
	btype = "wood", cost = "1w,1c", reward = "4vp",
	is_builder = true, builder_type = "residence",
	tile_id = 13 }
ARCHITECT = {
	name = "Architect", id = "architect",
	description = "Converts residences to prestige buildings",
	btype = "stone", cost = "1s,1f", reward = "6vp",
	is_builder = true, builder_type = "prestige",
	tile_id = 15, supply = 2 }
BANK = { name = "Bank", id = "bank",
	description = "Cash in money for gold",
	btype = "stone", cost = "1s,1w", reward = "6vp", tile_id = 16 }
JEWELER = { name = "Jeweler", id = "jeweler",
	description = "Cash in gold for victory points",
	btype = "stone", cost = "1s,1c", reward = "6vp", tile_id = 17 }
ALCHEMIST = { name = "Alchemist", id = "alchemist",
	description = "Convert resources to gold",
	btype = "stone", cost = "1s,1f", reward = "6vp", tile_id = 18 }
CHURCH = { name = "Church", id = "church",
	description = "Cash in money for victory points",
	btype = "stone", cost = "1s,1c", reward = "3vp", reward_favor = 1, tile_id = 21 }
TAILOR = {
	name = "Tailor", id = "tailor",
	description = "Gives victory points for cloth",
	btype = "stone", cost = "1s,1w", reward = "6vp",
	tile_id = 23 }

SPECIAL_BUILDINGS = {
		GATE,
		TRADING_POST,
		MERCHANT_GUILD,
		JOUST_FIELD,
		STABLES,
		INN,
		BRIDGE,
		PEDDLER1,
		CARPENTER2,
		GOLD_MINE,
		CASTLE,
	}
NEUTRAL_BUILDINGS = {
		CARPENTER1,
		MARKETPLACE1,
		{ name = "Quarry", description = "Gives one stone.", id = "neutral-1s", actions = { "take 1s" }, tile_id = 6 },
		{ name = "Farm", description = "Gives one cloth or one food.", id = "neutral-1c/f", actions = { "take 1f", "take 1c" }, tile_id = 4 },
		{ name = "Sawmill", description = "Gives one wood.", id = "neutral-1w", actions = { "take 1w" }, tile_id = 2 },
		{ name = "Forest", description = "Gives one food or one wood.", id = "neutral-1f/w", actions = { "take 1w", "take 1f" }, tile_id = 3 },
	}
WOOD_BUILDINGS = {
	{ name = "Sawmill", id = "wood-2w", description = "Gives two wood",
	btype = "wood", actions = { "take 2w" }, cost = "1w,1f", reward = "2vp", tile_id = 8 },
	{ name = "Farm", id = "wood-2f", description = "Gives two food or one cloth",
	btype = "wood", actions = { "take 2f", "take 1c" }, cost = "1w,1f", reward = "2vp", tile_id = 12 },
	{ name = "Farm", id = "wood-2c", description = "Gives two cloth or one food",
	btype = "wood", actions = { "take 2c", "take 1f" }, cost = "1w,1f", reward = "2vp", tile_id = 10 },
	{ name = "Quarry", id = "wood-2s", description = "Gives two stone",
	btype = "wood", actions = { "take 2s" }, cost = "1w,1f", reward = "2vp", tile_id = 14 },
	MASON,
	PEDDLER2,
	LAWYER,
	MARKETPLACE2,
	}
STONE_BUILDINGS = {
	{ name = "Farm", id = "stone-ffc", description = "Gives two food and one cloth",
	btype = "stone", actions = { "take 2f,1c" }, owner_actions = { "take 1f", "take 1c" }, cost = "1s,1f", reward = "3vp", tile_id = 19 },
	{ name = "Park", id = "stone-wwf", description = "Gives two wood and one food",
	btype = "stone", actions = { "take 2w,1f" }, owner_actions = { "take 1w", "take 1f" }, cost = "1s,1f", reward = "3vp", tile_id = 20 },
	{ name = "Workshop", id = "stone-ssc", description = "Gives two stone and one cloth",
	btype = "stone", actions = { "take 2s,1c" }, owner_actions = { "take 1s", "take 1c" }, cost = "1s,1f", reward = "3vp", tile_id = 22 },
	ARCHITECT,
	BANK,
	ALCHEMIST,
	CHURCH,
	TAILOR,
	JEWELER,
	}
PRESTIGE_BUILDINGS = {
	{ name = "Statue", btype = "prestige", id = "statue",
	worker_limit = 0, cost = "2s,1g", reward = "7vp", reward_favor = 1, tile_id = 25 },
	{ name = "Weaver", btype = "prestige", id = "weaver",
	worker_limit = 0, cost = "3c,1g", reward = "12vp", tile_id = 26 },
	{ name = "Library", btype = "prestige", id = "library",
	worker_limit = 0, cost = "3w,1g", reward = "10vp", income = 1,
	tile_id = 27 },
	{ name = "Hotel", btype = "prestige", id = "hotel",
	worker_limit = 0, cost = "3s,2g", reward = "16vp", income = 2,
	tile_id = 28 },
	{ name = "Granary", btype = "prestige", id = "granary",
	worker_limit = 0, cost = "3f,1g", reward = "10vp", tile_id = 29 },
	{ name = "Theater", btype = "prestige", id = "theater",
	worker_limit = 0, cost = "3w,2g", reward = "14vp", reward_favor = 1, tile_id = 30 },
	{ name = "College", btype = "prestige", id = "college",
	worker_limit = 0, cost = "3s,2g", reward = "14vp", reward_favor = 1, tile_id = 31 },
	{ name = "Monument", btype = "prestige", id = "monument",
	worker_limit = 0, cost = "4s,2g", reward = "14vp", reward_favor = 2, tile_id = 32 },
	{ name = "Cathedral", btype = "prestige", id = "cathedral",
	worker_limit = 0, cost = "5s,3g", reward = "25vp", tile_id = 33 },
	}
RESIDENCE =
	{ name = "Residence", id = "residence",
	description = "Gives one coin to owner each round",
	worker_limit = 0, cost = "1c,1$", reward = "2vp", income = 1,
	btype = "residence", supply = math.huge,
	tile_id = 24 }
ALL_BUILDINGS = {
	residence = RESIDENCE
	}
for i,bldgref in ipairs(WOOD_BUILDINGS) do
	ALL_BUILDINGS[bldgref.id] = bldgref
end
for i,bldgref in ipairs(STONE_BUILDINGS) do
	ALL_BUILDINGS[bldgref.id] = bldgref
end
for i,bldgref in ipairs(PRESTIGE_BUILDINGS) do
	ALL_BUILDINGS[bldgref.id] = bldgref
end
for i,bldgref in ipairs(NEUTRAL_BUILDINGS) do
	ALL_BUILDINGS[bldgref.id] = bldgref
end
for i,bldgref in pairs(SPECIAL_BUILDINGS) do
	ALL_BUILDINGS[bldgref.id] = bldgref
end

--rules
USE_FAVORS = false
USE_PROVOST = false
NO_PASS_REWARD = false

function set_seed(seed)
	math.randomseed(seed)
	state.seed = seed
end

function init(player_count, seed)
	game_tree = {}
	current_node = game_tree
	new_game(player_count, seed)
end

function new_game(player_count, seed)
	local new_node = {
		parent = current_node,
		PlayerCount = player_count,
		Seed = seed,
		}

	state_init(player_count, seed)
	local s = state
			if s.seed then
				new_node.Seed = tostring(s.seed)
			end
			new_node.Rules = encode_rules()
			new_node.PlayerCount = tostring(#s.order)
			new_node.Order = table.concat(s.order, ",")
			for b = 1,LAST_EMPTY_POSITION do
				local bldgref = s.buildings[b].ref
				if bldgref and bldgref.id then
					local v = bldgref.id
					if s.buildings[b].owner then
						v = string.format("%s,%d",v,s.buildings[b].owner)
					end

					new_node[string.format("Building%d",b)] = v
				end
			end --loop through buildings

	current_node.child = new_node
	current_node = new_node
	current_node.state = state
	refresh_game_properties()
end

function init_player_money()
	for i,player_id in ipairs(state.order) do
		--initial money according to rulebook
		if i == 1 or #state.order == 2 then
			state.players[player_id].resources.money = 5
		elseif i == 2 or i == 3 then
			state.players[player_id].resources.money = 6
		else
			state.players[player_id].resources.money = 7
		end
		--first turn's income
		state.players[player_id].resources.money = state.players[player_id].resources.money + 2
	end
end

function state_init(player_count, seed)
	state = {
		phase = PHASE_WORKER_PLACEMENT,
		turn = 1,
		active_building = 0,
		round = 1,
		castle_phase = 1,
		resident = nil,
		bailiff = BAILIFF_START_POSITION,
		provost = BAILIFF_START_POSITION,
		contribution_count = 0,
		contributions = {},
		order = { },
		players = { },
		best_contribution_amount = 0,
		best_contribution_player = nil,
		favors_left = 0,
		favors_active = false,
		}
	for i = 1,(player_count or 2) do
		init_player(PLAYERS_INFO[i])
	end
	if seed then
		set_seed(seed)
	end
	shuffle(state.order)
	init_player_money()
	local mybuildings = {}
	for i = 1,36 do
		mybuildings[i] = setmetatable(
			{ ref = nil, occupants = {} },
			caylus.building_mt)
	end
	mybuildings[1].ref = SPECIAL_BUILDINGS[1]
	mybuildings[2].ref = SPECIAL_BUILDINGS[2]
	mybuildings[3].ref = SPECIAL_BUILDINGS[3]
	mybuildings[4].ref = SPECIAL_BUILDINGS[4]
	mybuildings[5].ref = SPECIAL_BUILDINGS[5]
	mybuildings[6].ref = SPECIAL_BUILDINGS[6]
	mybuildings[7].ref = SPECIAL_BUILDINGS[7]
	init_neutral_buildings(mybuildings)
	mybuildings[14].ref = SPECIAL_BUILDINGS[8]
	mybuildings[15].ref = SPECIAL_BUILDINGS[9]
	mybuildings[GOLDMINE_POSITION].ref = SPECIAL_BUILDINGS[10]  --goldmine
	mybuildings[CASTLE_POSITION].ref = SPECIAL_BUILDINGS[11]  --castle
	state.buildings = mybuildings

	local my_unbuilt = {}
	for i,bref in ipairs(WOOD_BUILDINGS) do
		my_unbuilt[bref.id] = bref.supply or 1
	end
	for i,bref in ipairs(STONE_BUILDINGS) do
		my_unbuilt[bref.id] = bref.supply or 1
	end
	for i,bref in ipairs(PRESTIGE_BUILDINGS) do
		my_unbuilt[bref.id] = bref.supply or 1
	end
	my_unbuilt[RESIDENCE.id] = RESIDENCE.supply
	state.unbuilt = my_unbuilt
end

function init_player(player_info)
	if not player_info.personality then
		player_info.personality = { select_move = select_random_move }
	end

	table.insert(state.players,
		{
		info = player_info,
  		score = 0,
		income = 2,
		resources = resource_bag.parse("2f,1w,5$"),
		workers_left = 6,
		passed = false,
		vp_favor = 0,
		money_favor = 0,
		resource_favor = 0,
		build_favor = 0,
		})
	table.insert(state.order, #state.players)
end

function clone1(t,f)
	local new = {}
	if f then
		for i,v in pairs(t) do
			new[i] = f(v)
		end
	else
		for i,v in pairs(t) do
			new[i] = v
		end
	end
	return new
end

function caylus.building_mt.add_occupant(bldg, player_id)
	bldg.occupants = clone1(bldg.occupants)
	table.insert(bldg.occupants, player_id)
end

function caylus.building_mt.clone(bldg)
	local nbldg = clone1(bldg)
	setmetatable(nbldg, caylus.building_mt)
	return nbldg
end

function caylus.building_mt.remove_occupant(bldg, slot)
	bldg.occupants = clone1(bldg.occupants)
	local player_id = bldg.occupants[slot]
	bldg.occupants[slot] = 0
	return player_id
end

function clone_game_state(game)
	local clone_building_state = caylus.building_mt.clone
	local clone_player_state =
		function(p)
			local np = clone1(p)
			np.resources = clone1(p.resources)
			return np
		end
	local new_game = clone1(game)
	setmetatable(new_game, caylus.state_mt)
	new_game.order = clone1(game.order)
	new_game.players = clone1(game.players, clone_player_state)
	new_game.buildings = clone1(game.buildings, clone_building_state)
	new_game.contributions = clone1(game.contributions)
	return new_game
end

caylus.state_mt.clone = clone_game_state

function shuffle(array)
	for i = 1, #array do
		local j = math.random(i,#array)
		local tmp = array[i]
		array[i] = array[j]
		array[j] = tmp
	end
end

function map(func, array)
	local new_array = {}
	for i,v in ipairs(array) do
		new_array[i] = func(v)
	end
	return new_array
end

function init_neutral_buildings(buildings)
	local nb = clone1(NEUTRAL_BUILDINGS);
	local pos = 8
	while # nb > 0 do
		local j = math.random(# nb)
		buildings[pos].ref = table.remove(nb, j)
		pos = pos + 1
	end
end

function available_moves_for_gate(player_id)
	local moves = { "noaction" }
	for i,bldg in ipairs(state.buildings) do
		if can_place_worker(player_id, i, bldg, false) then
			table.insert(moves, string.format("gate %d", i))
		end
	end
	return moves
end

--- Says whether "claim N" is a valid move
-- @param player_id
-- @param position
-- @param building
-- @param check_cost if true, then the cost to place the worker is
--    is considered (usually you will want this)
-- @return true if it is a valid move; false otherwise
function can_place_worker(player_id, position, building, check_cost)

	--cannot place worker unless a building is here
	if not building.ref then
		return false
	end

	--check whether the "noprovost" rule is in effect
	if not USE_PROVOST then
		if position > state.provost and position < CASTLE_POSITION then
			return false
		end
		if building.ref == MERCHANT_GUILD then
			return false
		end
	end

	--in a two-player game, the STABLES is not a valid position
	if #state.order == 2 and building.ref == STABLES then
		return false
	end

	--check whether player is already at this building
	for j = 1,#building.occupants do
		if building.occupants[j] == player_id then
			--cannot place a second worker at this location
			return false
		end
	end

	--check whether this building has room for additional players
	local slots_count = building.ref.worker_limit or 1
	local slots_left = slots_count - #building.occupants
	if slots_left >= 1 then
		if check_cost then
			local cost = get_cost_to_place_worker(player_id, building)
			return state.players[player_id].resources.money >= cost
		else
			return true
		end
	else
		return false
	end
end

function available_moves_for_inn()
	if state.turn == TURN_OWNER_ACTION then
		return { "inn leave", "noaction" }
	else
		return { "inn enter" }
	end
end

--tells the UI what sort of choice is required of the current player
function current_phase()
	if state.active_building == 0 then
		if state.phase == PHASE_SCORING then
			return PHASE_FAVOR
		else
			return PHASE_WORKER_PLACEMENT
		end
	elseif state.favors_active then
		return PHASE_FAVOR
	else
		local bldg = state.buildings[state.active_building]
		if bldg.ref == GATE then
			return PHASE_GATE
		elseif bldg.ref == MERCHANT_GUILD or bldg.ref == BRIDGE then
			return PHASE_MOVE_PROVOST
		elseif bldg.ref.is_builder then
			return PHASE_SELECT_BUILDING
		elseif bldg.ref == CASTLE then
			return PHASE_CASTLE_BUILD
		elseif bldg.ref and bldg.ref.actions then
			return PHASE_PICKUP_PROFIT
		end
		return PHASE_ACTIVATE_BUILDINGS
	end
end

function all_available_moves()
	if state.turn == TURN_BOARD_ACTION then
		return { "auto" }
	end

	if state.favors_active then
		return available_moves_for_favor()
	elseif state.phase == PHASE_WORKER_PLACEMENT then
		local moves = { "pass" }
		local player_id = current_turn()
		local player_info = state.players[player_id]
		if player_info.workers_left < 1 or player_info.resources.money < 1 then
			--only move available is "pass"
			return moves
		end
		for i,bldg in ipairs(state.buildings) do
			if can_place_worker(player_id, i, bldg, true) then
				table.insert(moves, string.format("claim %d", i))
			end
		end
		return moves
	elseif state.phase == PHASE_ACTIVATE_BUILDINGS then
		local bldg = state.buildings[state.active_building]
		if state.turn == TURN_OWNER_ACTION and bldg.ref.owner_actions then
			return bldg.ref.owner_actions
		elseif bldg.ref.actions then
			return bldg.ref.actions
	--special fixed buildings
		elseif bldg.ref == GATE then
			return available_moves_for_gate(current_turn())
		elseif bldg.ref == MERCHANT_GUILD
				or bldg.ref == BRIDGE then
			return available_moves_for_provost(state.players[current_turn()])
		elseif bldg.ref == JOUST_FIELD then
			return available_moves_for_joust()
		elseif bldg.ref == INN then
			return available_moves_for_inn()
		elseif bldg.ref == CASTLE then
			return available_moves_for_castle()
	--regular buildings
		elseif bldg.ref == ALCHEMIST then
			return available_moves_for_alchemist()
		elseif bldg.ref.id == "lawyer" then
			return available_moves_for_lawyer()
		elseif bldg.ref.is_builder then
			return available_moves_for_builder(bldg.ref.builder_type)
		elseif bldg.ref == BANK then
			return available_moves_for_bank()
		elseif bldg.ref == CHURCH then
			return available_moves_for_church()
		elseif bldg.ref == JEWELER then
			return available_moves_for_jeweler()
		elseif bldg.ref == MARKETPLACE1 then
			return available_moves_for_marketplace("4$")
		elseif bldg.ref == MARKETPLACE2 then
			return available_moves_for_marketplace("6$")
		elseif bldg.ref == PEDDLER1 then
			return available_moves_for_peddler(1)
		elseif bldg.ref == PEDDLER2 then
			return available_moves_for_peddler(2)
		elseif bldg.ref == TAILOR then
			return available_moves_for_tailor()
		else
			return { "noaction" }
		end
	else
		assert(false, "cannot generate moves in this phase")
		return {}
	end
end

function available_moves_for_alchemist()
	local pr = state.players[current_turn()].resources
	local moves = { "noaction" }
	local helperfn
	helperfn =
	function(x,f,w,s,c)
		if x <= 1 and pr.food - f >= 1 then
			helperfn(1,f+1,w,s,c)
		end
		if x <= 2 and pr.wood - w >= 1 then
			helperfn(2,f,w+1,s,c)
		end
		if x <= 3 and pr.stone - s >= 1 then
			helperfn(3,f,w,s+1,c)
		end
		if x <= 4 and pr.cloth - c >= 1 then
			helperfn(4,f,w,s,c+1)
		end
		local n = f+w+s+c
		if n == 2 or n == 4 then
			local things = string.format("%s%s%s%s",
				(f>0 and string.format(",%df",f) or ""),
				(w>0 and string.format(",%dw",w) or ""),
				(s>0 and string.format(",%ds",s) or ""),
				(c>0 and string.format(",%dc",c) or ""))
			table.insert(moves,
				string.format("exchange %s %dg",
					string.sub(things,2),
					(n == 4 and 2 or 1)))
		end
	end

	helperfn(0,0,0,0,0)
	return moves
end

function available_moves_for_bank()
	local player = state.players[current_turn()]
	local moves = { "noaction" }
	if player.resources.money >= 2 then
		table.insert(moves, "exchange 2$ 1g")
	end
	if player.resources.money >= 5 then
		table.insert(moves, "exchange 5$ 2g")
	end
	return moves
end

function generate_castle_choices(player_id, callbackfn)
	local helperfn
	helperfn =
		function(x, f, w, s, c, g, taken)
			if x <= 1 and f >= 1 and w >= 1 and s >= 1 then
				helperfn(1, f-1, w-1, s-1, c, g, taken.."fws")
			end
			if x <= 2 and f >= 1 and w >= 1 and c >= 1 then
				helperfn(2, f-1, w-1, s, c-1, g, taken.."fwc")
			end
			if x <= 3 and f >= 1 and w >= 1 and g >= 1 then
				helperfn(3, f-1, w-1, s, c, g-1, taken.."fwg")
			end
			if x <= 4 and f >= 1 and s >= 1 and c >= 1 then
				helperfn(4, f-1, w, s-1, c-1, g, taken.."fsc")
			end
			if x <= 5 and f >= 1 and s >= 1 and g >= 1 then
				helperfn(5, f-1, w, s-1, c, g-1, taken.."fsg")
			end
			if x <= 6 and f >= 1 and c >= 1 and g >= 1 then
				helperfn(6, f-1, w, s, c-1, g-1, taken.."fcg")
			end
			callbackfn(taken)
		end
	local player = state.players[current_turn()]
	local slots_left = CASTLE_CONTRIBUTION_THRESHOLDS[3] - state.contribution_count
	helperfn(0,
		math.min(player.resources.food, slots_left),
		player.resources.wood,
		player.resources.stone,
		player.resources.cloth,
		player.resources.gold,
		"")
end

function available_moves_for_castle()
	local moves = {}
	local add_choice =
		function(taken)
			if taken == "" then
				table.insert(moves, "castle nobuild")
			else
				table.insert(moves, string.format("castle %s", taken))
			end
		end
	generate_castle_choices(current_turn(), add_choice)
	return moves
end

function max_favor_level()
	return
			state.castle_phase == 3 and 5
			or state.castle_phase == 2 and 4
			or 2
end

function available_moves_for_church()
	local player = state.players[current_turn()]
	local moves = { "noaction" }
	if player.resources.money >= 2 then
		table.insert(moves, "exchange 2$ 3vp")
	end
	if player.resources.money >= 4 then
		table.insert(moves, "exchange 4$ 5vp")
	end
	return moves
end

function available_moves_for_favor()
	local player = state.players[current_turn()]
	local max_favor = max_favor_level()

	if not USE_FAVORS then
		return { "favor 3vp" }
	end

	local moves = {}
	if not player.vp_favor_used then
		local vp_move = string.format("favor %d", math.min(player.vp_favor + 1, max_favor)) .. "vp"
		table.insert(moves, vp_move)
	end

	if not player.money_favor_used then
		local money_move = string.format("favor %d", math.min(player.money_favor + 1, max_favor) + 2) .. "$"
		table.insert(moves, money_move)
	end

	if not player.resource_favor_used then
		local resource_level = math.min(player.resource_favor + 1, max_favor)
		table.insert(moves, "favor 1f")
		if resource_level >= 2 then
			table.insert(moves, "favor 1w")
			table.insert(moves, "favor 1s")
		end
		if resource_level >= 3 then
			table.insert(moves, "favor 1c")
		end
		if resource_level >= 4 then
			-- exchange options
			if player.resources.food >= 1 then
				table.insert(moves, "favor exchange 1f 2w")
				table.insert(moves, "favor exchange 1f 1w,1s")
				table.insert(moves, "favor exchange 1f 1w,1c")
				table.insert(moves, "favor exchange 1f 2s")
				table.insert(moves, "favor exchange 1f 1s,1c")
				table.insert(moves, "favor exchange 1f 2c")
			end
			if player.resources.wood >= 1 then
				table.insert(moves, "favor exchange 1w 2f")
				table.insert(moves, "favor exchange 1w 1f,1s")
				table.insert(moves, "favor exchange 1w 1f,1c")
				table.insert(moves, "favor exchange 1w 2s")
				table.insert(moves, "favor exchange 1w 1s,1c")
				table.insert(moves, "favor exchange 1w 2c")
			end
			if player.resources.stone >= 1 then
				table.insert(moves, "favor exchange 1s 2f")
				table.insert(moves, "favor exchange 1s 1f,1w")
				table.insert(moves, "favor exchange 1s 1f,1c")
				table.insert(moves, "favor exchange 1s 2w")
				table.insert(moves, "favor exchange 1s 1w,1c")
				table.insert(moves, "favor exchange 1s 2c")
			end
			if player.resources.cloth >= 1 then
				table.insert(moves, "favor exchange 1c 2f")
				table.insert(moves, "favor exchange 1c 1f,1w")
				table.insert(moves, "favor exchange 1c 1f,1s")
				table.insert(moves, "favor exchange 1c 2w")
				table.insert(moves, "favor exchange 1c 1w,1s")
				table.insert(moves, "favor exchange 1c 2s")
			end
			if player.resources.gold >= 1 then
				table.insert(moves, "favor exchange 1g 2f")
				table.insert(moves, "favor exchange 1g 1f,1w")
				table.insert(moves, "favor exchange 1g 1f,1s")
				table.insert(moves, "favor exchange 1g 1f,1c")
				table.insert(moves, "favor exchange 1g 2w")
				table.insert(moves, "favor exchange 1g 1w,1s")
				table.insert(moves, "favor exchange 1g 1w,1c")
				table.insert(moves, "favor exchange 1g 2s")
				table.insert(moves, "favor exchange 1g 1s,1c")
				table.insert(moves, "favor exchange 1g 2c")
			end
		end
		if resource_level >= 5 then
			table.insert(moves, "favor 1g")
		end
	end --if resource favor not already used

	if not player.build_favor_used then
		local bldg_level = math.min(player.build_favor + 1, max_favor)
		table.insert(moves, "favor build")
		if bldg_level >= 2 then
			--wood buildings, discounted 1 wood
			local options = generate_build_options("wood", "1w")
			for i,option in ipairs(options) do
				for pmt,j in pairs(option.pay_options) do
					table.insert(moves, string.format("favor wood %s %s na", option.movestr, pmt))
				end
			end
		end
		if bldg_level >= 3 then
			--stone buildings, discounted 1 stone
			local options = generate_build_options("stone", "1s")
			for i,option in ipairs(options) do
				for pmt,j in pairs(option.pay_options) do
					table.insert(moves, string.format("favor stone %s %s na", option.movestr, pmt))
				end
			end
		end
		if bldg_level >= 4 then
			--residence, discounted 1 coin
			local options = generate_build_options("residence", "1$")
			for i,option in ipairs(options) do
				for pmt,j in pairs(option.pay_options) do
					for loc,k in pairs(option.loc_options) do
						table.insert(moves, string.format("favor residence %s %s %s", option.movestr, pmt, loc))
					end
				end
			end
		end
		if bldg_level >= 5 then
			--prestige building (no discount)
			local options = generate_build_options("prestige")
			for i,option in ipairs(options) do
				for pmt,j in pairs(option.pay_options) do
					for loc,k in pairs(option.loc_options) do
						table.insert(moves, string.format("favor prestige %s %s %s", option.movestr, pmt, loc))
					end
				end
			end
		end
	end

	if #moves == 0 then
		return { "favor pass" }
	end

	return moves
end

function available_moves_for_jeweler()
	local player = state.players[current_turn()]
	local moves = { "noaction" }
	if player.resources.gold >= 1 then
		table.insert(moves, "exchange 1g 5vp")
	end
	if player.resources.gold >= 2 then
		table.insert(moves, "exchange 2g 9vp")
	end
	return moves
end

function available_moves_for_joust()
	local player = state.players[current_turn()]
	if player.resources.money >= 1 and player.resources.cloth >= 1 then
		player.resources.money = player.resources.money - 1
		player.resources.cloth = player.resources.cloth - 1
		local moves = available_moves_for_favor()
		player.resources.money = player.resources.money + 1
		player.resources.cloth = player.resources.cloth + 1
		table.insert(moves, "noaction")
		return moves
	else
		return { "noaction" }
	end
end

function available_moves_for_lawyer()
	return available_moves_for_builder("residence")
end

function available_moves_for_peddler(level)
	local player = state.players[current_turn()]
	local moves = { "noaction" }
	local cost1 = level == 2 and 1 or 2
	local TYPES = { "f", "w", "s", "c" }
	if player.resources.money >= cost1 then
		for i,t in ipairs(TYPES) do
			table.insert(moves, string.format("exchange %d$ 1%s", cost1, t))
		end
	end
	if level == 2 and player.resources.money >= 2 then
		for i = 1,#TYPES do
			for j = i, #TYPES do
				if i == j then
					table.insert(moves, string.format("exchange 2$ 2%s", TYPES[i]))
				else
					table.insert(moves, string.format("exchange 2$ 1%s,1%s",
							TYPES[i], TYPES[j]))
				end
			end
		end
	end
	return moves
end

function available_moves_for_tailor()
	local player = state.players[current_turn()]
	local moves = { "noaction" }
	if player.resources.cloth >= 2 then
		table.insert(moves, "exchange 2c 4vp")
	end
	if player.resources.cloth >= 3 then
		table.insert(moves, "exchange 3c 6vp")
	end
	return moves
end

--checks whether the specified building has been built yet
function is_built(building_ref)
	for j,bldg in ipairs(state.buildings) do
		if bldg.ref == building_ref then
			return true
		end
	end
	return false
end

--checks whether the specified building is still available to
--be built. Note: this is NOT a strict opposite to is_built(),
--since a building can both be built and still be available to be
--built if there is more than one copy of it (e.g. Architect).
function is_unbuilt(building_id)
	if state.unbuilt[building_id] and state.unbuilt[building_id] >= 1 then
		return true
	else
		return false
	end
end

function available_moves_for_builder(building_type)
	local moves = { "noaction" }
	local options = generate_build_options(building_type)
	for i,option in ipairs(options) do
		for pmt,j in pairs(option.pay_options) do
			for loc,k in pairs(option.loc_options) do
				table.insert(moves, string.format("build %s %s %s", option.movestr, pmt, loc))
			end
		end
	end
	return moves
end

--- Builds an "options" list, providing a list of what buildings
-- can be built and attributes about those buildings.
-- Each element of the list returned is an object with:
--   .movestr - a partial move string
--   .pay_options - a set of valid payments
--   .loc_options - a set of valid locations
--
-- The player should pick a move by selecting a payment and a location,
-- and concatenating the strings as follows:
--   "build "..MOVESTR.." "..PAYMENT.." "..LOCATION
--
function generate_build_options(building_type, discount)
	local player_id = current_turn()
	local player = state.players[player_id]
	local options = {}
	local building_set = building_type == "wood" and WOOD_BUILDINGS
			or building_type == "stone" and STONE_BUILDINGS
			or building_type == "residence" and { RESIDENCE }
			or building_type == "prestige" and PRESTIGE_BUILDINGS
			or {}

	local helperfn =
		function(pay_options, cost)
			if discount then
				if discount == "1w" then
					if cost == "1w,1f" then cost = "1f"
					elseif cost == "2w" then cost = "1w"
					elseif cost == "1w,1s" then cost = "1s"
					elseif cost == "1w,1c" then cost = "1c"
					elseif cost == "1w,1g" then cost = "1g"
					end
				elseif discount == "1s" then
					if cost == "1s,1f" then cost = "1f"
					elseif cost == "1s,1w" then cost = "1w"
					elseif cost == "2s" then cost = "1s"
					elseif cost == "1s,1c" then cost = "1c"
					elseif cost == "1s,1g" then cost = "1g"
					end
				elseif discount == "1$" then
					if cost == "1c,1$" then cost = "1c"
					end
				end
			end
			if check_cost(player, cost) then
				pay_options[cost] = 1
			end
		end

	for i,bldgref in ipairs(building_set) do
		-- check whether this building is in the supply
		if is_unbuilt(bldgref.id) then
			--check whether the player can afford it
			local my_pay_options = {}
			if bldgref.cost == "1w,1_" then
				for j,mycost in ipairs({"1w,1f","2w","1w,1s","1w,1c","1w,1g"}) do
					helperfn(my_pay_options, mycost)
				end
			else
				helperfn(my_pay_options, bldgref.cost)
			end
			--generate location options
			local my_loc_options = {}
			if building_type == "residence" then
				get_eligible_residence_locations(my_loc_options, player_id)
			elseif building_type == "prestige" then
				get_eligible_prestige_locations(my_loc_options, player_id)
			else
				my_loc_options["na"] = 1
			end

			table.insert(options, {
				movestr = bldgref.id,
				pay_options = my_pay_options,
				loc_options = my_loc_options,
				})
		end
	end

	return options
end

function get_eligible_residence_locations(loc_options, player_id)
	--neutral buildings
	for i = 8,13 do
		if (not state.buildings[i].owner)
				and (not state.buildings[i].delay_building) then
			loc_options[i] = 1
		end
	end
	--player owned buildings
	for i = FIRST_EMPTY_POSITION, LAST_EMPTY_POSITION do
		local bldg = state.buildings[i]
		if bldg.owner == player_id
				and (not bldg.delay_build)
				and (bldg.ref
					and (bldg.ref.btype == "wood" or bldg.ref.btype == "stone")
					and bldg.ref.id ~= "lawyer"
					) then
			loc_options[i] = 1
		end
	end
end

function get_eligible_prestige_locations(loc_options, player_id)
	--look for player-owned residences
	for i = 8, LAST_EMPTY_POSITION do
		local bldg = state.buildings[i]
		if bldg.owner == player_id
				and (not bldg.delay_build)
				and (bldg.ref
					and (bldg.ref.btype == "residence")
					) then
			loc_options[i] = 1
		end
	end
end

function available_moves_for_marketplace(payout)
	local player = state.players[current_turn()]
	local moves = { "noaction" }
	if player.resources.food > 0 then
		table.insert(moves, "exchange 1f "..payout)
	end
	if player.resources.wood > 0 then
		table.insert(moves, "exchange 1w "..payout)
	end
	if player.resources.stone > 0 then
		table.insert(moves, "exchange 1s "..payout)
	end
	if player.resources.cloth > 0 then
		table.insert(moves, "exchange 1c "..payout)
	end
	if player.resources.gold > 0 then
		table.insert(moves, "exchange 1g "..payout)
	end
	return moves
end

function available_moves_for_provost(player)
	local moves = { "noaction" }
	for i = 1,3 do
		if state.active_building == MERCHANT_GUILD_POSITION or player.resources.money >= i then
			if state.provost + i < CASTLE_POSITION then
				table.insert(moves, string.format("provost %d", i))
			end
			if state.provost - i > BRIDGE_POSITION then
				table.insert(moves, string.format("provost %d", -i))
			end
		end
	end
	return moves
end

function is_my_turn(whoami)
	if state.turn == TURN_BOARD_ACTION then
		return false
	elseif state.phase == PHASE_END then
		return false
	else
		return whoami == current_turn()
	end
end

function current_turn()
	if state.phase == PHASE_WORKER_PLACEMENT or state.phase == PHASE_SCORING then
		return state.order[state.turn]
	elseif state.phase == PHASE_ACTIVATE_BUILDINGS then
		if state.turn == TURN_OWNER_ACTION then
			return state.buildings[state.active_building].owner
		elseif state.turn == TURN_BOARD_ACTION then
			error("current_turn() called on board's turn")
		else
			return state.buildings[state.active_building].occupants[state.turn]
		end
	elseif state.phase == PHASE_CASTLE_FAVOR then
		return state.best_contribution_player
	else
		error("current_turn() called at end of game")
	end
end

function string:split(pat)
   local st = 1
   local g = self:gmatch("()"..pat.."()")
   local function splitter(self)
     if st then
       local s, f = g()
       local rv = self:sub(st, (s or 0)-1)
       st = f
       return rv
     end
   end
   return splitter, self
end

function keys(t)
	local a = {}
	for k,v in pairs(t) do
		table.insert(a, k)
	end
	return a
end

function check_move(move)
	local moves = all_available_moves()
	for i,m in ipairs(moves) do
		if m == move then
			return true
		end
	end
	return false
end

local function cost_str_coins(num_coins)
	return string.format("%d$", num_coins)
end

function do_move(move)
	describe_last_move = function() return move end

	if current_node.state == state then
		current_node.state = nil
		--look for an existing move
		local new_node = current_node.child
		while new_node and new_node.M ~= move do
			new_node = new_node.sibling
		end
		if not new_node then
			--create a new move
			local t = state.turn ~= TURN_BOARD_ACTION
				and current_turn()
			new_node = {
				parent = current_node,
				M = move,
				Turn = t,
				}
			new_node.sibling = current_node.child
			current_node.child = new_node
		end
		current_node = new_node
		current_node.state = state
	end

	if move == "auto" then
		return do_move_auto()
	end

	local words = {}
	for k in move:split("%s+") do words[#words + 1] = k end

	local player_id = current_turn()
	assert(player_id >= 1 and player_id <= #state.order, "invalid current turn")

	local cmd = table.remove(words, 1)
	if cmd == "pass" then
		do_move_pass(player_id)
	elseif cmd == "build" then
		do_move_build(player_id, words[1], words[2], words[3])
	elseif cmd == "castle" then
		do_move_castle(player_id, words[1])
	elseif cmd == "claim" then
		do_move_place_worker(player_id, tonumber(words[1]))
	elseif cmd == "exchange" then
		do_move_exchange(player_id, words[1], words[2])
	elseif cmd == "favor" then
		do_move_favor(player_id, words)
	elseif cmd == "gate" then
		do_move_gate(tonumber(words[1]))
	elseif cmd == "inn" then
		do_move_inn(player_id, words[1])
	elseif cmd == "noaction" then
		do_move_decline_action(player_id)
	elseif cmd == "provost" then
		do_move_provost(player_id, tonumber(words[1]))
	elseif cmd == "take" then
		do_move_take(player_id, words)
	else
		assert(false, "unrecognized command " .. cmd)
	end
	next_turn()
end

function do_move_auto()
	assert(state.turn == TURN_BOARD_ACTION)
	do_board_action()
end

function grant_favors(num_favors)
	state.favors_left = state.favors_left + num_favors
end

--- format of a build string is
--   build BUILDING_ID PAYMENT POSITION
--
-- In older versions of Caylus, the format was
--   build BTYPE BNUMBER[,POSITION] PAYMENT
--
function do_move_build(player_id, building_name, arg2, arg3)
	local bldgref = nil
	local payment
	local position
	if building_name == "wood" then
		--this is a legacy build command for wood buildings
		local id = tonumber(arg2)
		bldgref = WOOD_BUILDINGS[id]
		payment = arg3
	elseif building_name == "stone" then
		--this is a legacy build command for stone buildings
		local id = tonumber(arg2)
		bldgref = STONE_BUILDINGS[id <= 4 and id or (id - 1)]
		payment = arg3
	elseif building_name == "residence" and string.match(arg2, ",%d+$") then
		--this is a legacy build command for residence
		local id,tmp_pos = string.match(arg2, "^(%d+),(%d+)$")
		bldgref = RESIDENCE
		payment = arg3
		position = tmp_pos
	elseif building_name == "prestige" then
		--this is a legacy build command for prestige buildings
		local id,tmp_pos = string.match(arg2, "^(%d+),(%d+)$")
		id = tonumber(id)
		bldgref = PRESTIGE_BUILDINGS[id]
		payment = arg3
		position = tmp_pos
	elseif ALL_BUILDINGS[building_name] then
		--this is the preferred build command format
		bldgref = ALL_BUILDINGS[building_name]
		payment = arg2
		position = arg3
	end
	assert(bldgref, "build: invalid type or id ("..building_name.."/"..arg2..")")

	if bldgref.btype == "residence" then
		return do_move_build_residence(player_id, bldgref, tonumber(position), payment)
	elseif bldgref.btype == "prestige" then
		return do_move_build_prestige(player_id, bldgref, tonumber(position), payment)
	end

	if payment == nil then
		payment = bldgref.cost
	end
	assert(payment, "build: no payment specified")
	assert(check_cost(state.players[player_id], payment), "build: cannot pay "..payment)
	--find an empty slot for this building
	local position = nil
	for j = FIRST_EMPTY_POSITION, LAST_EMPTY_POSITION do
		if state.buildings[j].ref == nil then
			position = j
			break
		end
	end
	assert(position, "build: no empty slots available")

	--deduct payment, increment score
	adjust_resources(state.players[player_id], -1, payment)
	if bldgref.reward then
		adjust_resources(state.players[player_id], 1, bldgref.reward)
	end
	if bldgref.reward_favor then
		grant_favors(bldgref.reward_favor)
	end

	--place the building
	state.buildings[position].ref = bldgref
	state.buildings[position].owner = player_id
	update_unbuilt(bldgref.id)
end

function update_unbuilt(bldg_id, delta)

	local new_unbuilt = clone1(state.unbuilt)
	new_unbuilt[bldg_id] = (new_unbuilt[bldg_id] or 0) + (delta or -1)
	assert(new_unbuilt[bldg_id] >= 0)

	if new_unbuilt[bldg_id] and new_unbuilt[bldg_id] < 1 then
		new_unbuilt[bldg_id] = nil
	end
	state.unbuilt = new_unbuilt
end

function do_move_build_residence(player_id, bldgref, position, payment)

	--deduct payment, increment score
	adjust_resources(state.players[player_id], -1, payment or bldgref.cost)
	adjust_resources(state.players[player_id], 1, bldgref.reward)

	--player now receives more income
	state.players[player_id].income = state.players[player_id].income
		+ (bldgref.income or 0)

	if state.active_building <= position and state.buildings[position].occupants[1] then
		--delayed build
		state.buildings[position].delay_build = bldgref
		state.buildings[position].delay_owner = player_id
		update_unbuilt(bldgref.id)
	else
		--the replaced building might go back to the supply
		local old_bldg = state.buildings[position].ref
		if old_bldg.btype == "wood" or old_bldg.btype == "stone" then
			update_unbuilt(old_bldg.id, 1)
		end

		--place the building now
		state.buildings[position].ref = bldgref
		state.buildings[position].owner = player_id
		update_unbuilt(bldgref.id)
	end
end

function do_move_build_prestige(player_id, bldgref, position, payment)

	--deduct payment, increment score
	adjust_resources(state.players[player_id], -1, bldgref.cost)
	if bldgref.reward then
		adjust_resources(state.players[player_id], 1, bldgref.reward)
	end
	if bldgref.reward_favor then
		grant_favors(bldgref.reward_favor)
	end

	--adjust player income
	local old_building = state.buildings[position].delay_build and
			state.buildings[position].delay_build or
			state.buildings[position].ref
	state.players[player_id].income = state.players[player_id].income
		- (old_building and old_building.income or 0)
		+ (bldgref.income or 0)

	if state.active_building <= position and state.buildings[position].occupants[1] then
		--delayed build
		state.buildings[position].delay_building = new_building
		state.buildings[position].delay_owner = player_id
		update_unbuilt(bldgref.id)
	else
		--place the building now
		state.buildings[position].ref = bldgref
		state.buildings[position].owner = player_id
		update_unbuilt(bldgref.id)
	end
end

function do_move_castle(player_id, contribution)
	local player = state.players[player_id]
	assert(player)
	assert(state.castle_phase <= 3)

	local my_castle_phase = state.castle_phase
	while state.contribution_count >= CASTLE_CONTRIBUTION_THRESHOLDS[my_castle_phase] do
		my_castle_phase = my_castle_phase + 1
		if my_castle_phase > 3 then break end
	end

	local count_points = 0
	local add_block =
		function()
			assert(my_castle_phase <= 3)
			state.contribution_count = state.contribution_count + 1
			state.contributions[state.contribution_count] = player_id
			count_points = count_points + (6 - my_castle_phase)
			if state.contribution_count >= CASTLE_CONTRIBUTION_THRESHOLDS[my_castle_phase] then
				my_castle_phase = my_castle_phase + 1
			end
		end

	if contribution == "nobuild" then
		--penalty for not building (2pts)
		player.score = math.max(player.score - 2, 0)
		describe_last_move = function()
				return "contributes no blocks"
			end
	else
		local count = 0
		for i = 1, string.len(contribution) do
			if my_castle_phase > 3 then break end
			local c = string.sub(contribution, i,i)
			if c == "f" then
				player.resources.food = player.resources.food - 1
			elseif c == "w" then
				player.resources.wood = player.resources.wood - 1
			elseif c == "s" then
				player.resources.stone = player.resources.stone - 1
			elseif c == "c" then
				player.resources.cloth = player.resources.cloth - 1
			elseif c == "g" then
				player.resources.gold = player.resources.gold - 1
			else
				assert(false, "what resource is '"..c.."'?")
			end
			if i % 3 == 0 then
				add_block()
				count = count + 1
			end
		end
		player.score = player.score + count_points
		if count > state.best_contribution_amount then
			state.best_contribution_amount = count
			state.best_contribution_player = player_id
		end
		describe_last_move = function() return
			string.format("contributes %s (%d %s) receiving %dvp",
				contribution,
				count,
				(count == 1 and "block" or "blocks"),
				count_points)
			end
	end
end

function do_move_inn(player_id, mode)
	if mode == "enter" then
		state.resident = player_id
	elseif mode == "leave" then
		state.resident = nil
	end
	state.buildings[INN_POSITION].owner = state.resident
end

function do_move_provost(player_id, offset)
	assert(player_id == current_turn(), "not that player's turn")
	local player = state.players[player_id]
	local cost = state.active_building == MERCHANT_GUILD_POSITION and 0 or math.abs(offset)
	assert(player.resources.money >= cost, "player does not have enough money")
	player.resources.money = player.resources.money - cost
	state.provost = state.provost + offset

	describe_last_move = function() return string.format("moves the provost %s %d %s%s",
			(offset > 0 and "forward" or "backward"),
			math.abs(offset),
			(math.abs(offset)==1 and "space" or "spaces"),
			(cost > 0 and " for "..cost_str_coins(cost) or "")
			)
	end
end

function do_move_take(player_id, things)
	assert(player_id == current_turn(), "not that player's turn")
	local player = state.players[player_id]
	for i,thing in ipairs(things) do
		adjust_resources(player, 1, thing)
	end
end

function do_move_favor(player_id, words)
	assert(player_id == current_turn(), "not that player's turn")
	local player = state.players[player_id]

	if state.active_building == JOUST_POSITION and not state.favors_active then
		--cost for jousting
		player.resources.money = player.resources.money - 1
		player.resources.cloth = player.resources.cloth - 1
	end

	local max_favor = max_favor_level()
	local use_favor =
		function(favor_type)
			player[favor_type.."_favor"] = math.min(player[favor_type.."_favor"] + 1, max_favor)
			player[favor_type.."_favor_used"] = true
		end

	if words[1] == "build" then
		assert(#words == 1, "invalid move")
		use_favor("build")
		return
	elseif words[1] == "wood" or words[1] == "stone" or words[1] == "residence" or words[1] == "prestige" then
		--build a building with the appropriate discount, etc.
		do_move_build(player_id, words[2], words[3], words[4])
		use_favor("build")
		return
	elseif string.match(words[1], "^(%d+)vp$") then
		--VP track
		if USE_FAVORS then
			use_favor("vp")
		end
		return do_move_take(player_id, words)
	elseif string.match(words[1], "^(%d+)($)$") then
		--money track
		use_favor("money")
		return do_move_take(player_id, words)
	elseif words[1] == "exchange" then
		--resource track, exchange
		use_favor("resource")
		return do_move_exchange(player_id, words[2], words[3])
	elseif words[1] == "pass" then
		return
	else
		--resource track
		use_favor("resource")
		return do_move_take(player_id, words)
	end
end

function check_cost_r(resources_struct, cost)
	local taking = resource_bag.parse(cost)
	return
		resources_struct.food >= taking.food and
		resources_struct.wood >= taking.wood and
		resources_struct.stone >= taking.stone and
		resources_struct.cloth >= taking.cloth and
		resources_struct.gold >= taking.gold and
		resources_struct.money >= taking.money
end

function check_cost(player_struct, cost)
	return check_cost_r(player_struct.resources, cost)
end

resource_bag = {
		clone = clone1,
	}
function resource_bag.new()
	return {
		food = 0, wood = 0, stone = 0, cloth = 0, gold = 0,
		score = 0, money = 0, favors = 0
		}
end

function resource_bag.subtract(lhs, rhs)
	return {
		food = lhs.food - rhs.food,
		wood = lhs.wood - rhs.wood,
		stone = lhs.stone - rhs.stone,
		cloth = lhs.cloth - rhs.cloth,
		gold = lhs.gold - rhs.gold,
		score = lhs.score - rhs.score,
		money = lhs.money - rhs.money,
		favors = lhs.favors - rhs.favors,
		}
end

function resource_bag.scale(bag, factor)
	return {
		food = bag.food * factor,
		wood = bag.wood * factor,
		stone = bag.stone * factor,
		cloth = bag.cloth * factor,
		gold = bag.gold * factor,
		score = bag.score * factor,
		money = bag.money * factor,
		favors = bag.favors * factor,
		}
end

function resource_bag.parse(things)
	local wallet = resource_bag.new()
	for thing in things:split(",") do
		local quantity,resource = string.match(thing, "^(%d+)([%w_$]+)$")
		assert(quantity and tonumber(quantity) > 0, "invalid resource expression ("..things..")")
		if resource == "f" then
			wallet.food = wallet.food + quantity
		elseif resource == "w" then
			wallet.wood = wallet.wood + quantity
		elseif resource == "s" then
			wallet.stone = wallet.stone + quantity
		elseif resource == "c" then
			wallet.cloth = wallet.cloth + quantity
		elseif resource == "g" then
			wallet.gold = wallet.gold + quantity
		elseif resource == "$" then
			wallet.money = wallet.money + quantity
		elseif resource == "vp" then
			wallet.score = wallet.score + quantity
		else
			assert(false, "don't know how to take " .. resource)
		end
	end
	return wallet
end

function resource_bag.as_string(bag)
	local strings = {}
	if bag.money ~= 0 then
		table.insert(strings, string.format("%d$", bag.money))
	end
	if bag.food ~= 0 then
		table.insert(strings, string.format("%df", bag.food))
	end
	if bag.wood ~= 0 then
		table.insert(strings, string.format("%dw", bag.wood))
	end
	if bag.stone ~= 0 then
		table.insert(strings, string.format("%ds", bag.stone))
	end
	if bag.cloth ~= 0 then
		table.insert(strings, string.format("%dc", bag.cloth))
	end
	if bag.gold ~= 0 then
		table.insert(strings, string.format("%dg", bag.gold))
	end
	return table.concat(strings, ",")
end

function adjust_resources(player, sign, things)
	local wallet = resource_bag.parse(things)
	player.resources.food = player.resources.food + sign * wallet.food
	player.resources.wood = player.resources.wood + sign * wallet.wood
	player.resources.stone = player.resources.stone + sign * wallet.stone
	player.resources.cloth = player.resources.cloth + sign * wallet.cloth
	player.resources.gold = player.resources.gold + sign * wallet.gold
	player.resources.money = player.resources.money + sign * wallet.money
	player.score = player.score + sign * wallet.score
end

function do_move_exchange(player_id, give, take)
	local player = state.players[player_id]
	adjust_resources(player, -1, give)
	adjust_resources(player, 1, take)
end

function do_move_decline_action(player_id)
	assert(player_id == current_turn(), "not that player's turn")
end

function do_move_pass(player_id)

	describe_last_move = function() return "passes" end

	assert(player_id == current_turn(), "not that player's turn")
	local player_struct = state.players[player_id]
	local num_passed = #(state.buildings[BRIDGE_POSITION].occupants)
	if num_passed == 0 and not NO_PASS_REWARD then
		player_struct.resources.money = player_struct.resources.money + 1
	end
	player_struct.passed = true
	state.buildings[BRIDGE_POSITION]:add_occupant(player_id)
end

function count_passed_players()
	local count = 0
	for i,name in ipairs(state.order) do
		if state.players[name].passed then
			count = count + 1
		end
	end
	return count
end

function next_turn()
	if state.favors_left >= 1 then
		state.favors_active = true
		state.favors_left = state.favors_left - 1
		return
	elseif state.favors_active then
		assert(state.favors_left == 0)
		state.favors_active = false
	end

	if state.phase == PHASE_WORKER_PLACEMENT then
		local orig = state.turn
		state.turn = (state.turn % #state.order) + 1
		while state.players[state.order[state.turn]].passed do
			if state.turn == orig then
				--everyone has passed
				return end_of_worker_placement_phase()
			end
			state.turn = (state.turn % #state.order) + 1
		end
		return
	elseif state.phase == PHASE_ACTIVATE_BUILDINGS then
		local building = state.buildings[state.active_building]
		local last_actor = building:remove_occupant(state.turn)
		if state.turn >= #building.occupants then
			--already processed all occupants of this building
			--check for owner actions
			if building.ref
					and building.ref.owner_actions
					and building.owner
					and building.owner ~= last_actor
					and state.turn == 1 then
				state.turn = TURN_OWNER_ACTION
				return
			else
				return next_building()
			end
		else
			state.turn = state.turn + 1
			return
		end
	elseif state.phase == PHASE_CASTLE_FAVOR then
		return end_of_castle_favor_phase()
	elseif state.phase == PHASE_SCORING then
		local phase_just_completed = state.castle_phase
		assert(phase_just_completed >= 1 and phase_just_completed <= 3)
		state.turn = state.turn + 1
		while state.turn <= #state.order do
			--check how many castle blocks this player contributed
			local player_id = state.order[state.turn]
			local i0 = (phase_just_completed > 1 and CASTLE_CONTRIBUTION_THRESHOLDS[phase_just_completed - 1] + 1 or 1)
			local i1 = CASTLE_CONTRIBUTION_THRESHOLDS[phase_just_completed]
			local count_blocks = 0
			for i = i0, i1 do
				if state.contributions[i] == player_id then
					count_blocks = count_blocks + 1
				end
			end
			--does this contribution deserve any favors?
			if count_blocks == 0 then
				--deduct points
				local penalty = NO_CONTRIBUTION_PENALTY[phase_just_completed]
				local player = state.players[player_id]
				player.score = math.max(0, player.score - penalty)
			elseif phase_just_completed == 1 and count_blocks >= 2 then
				grant_favors(1)
				return next_turn()
			elseif phase_just_completed == 2 and count_blocks >= 5 then
				grant_favors(3)
				return next_turn()
			elseif phase_just_completed == 2 and count_blocks >= 3 then
				grant_favors(2)
				return next_turn()
			elseif phase_just_completed == 2 and count_blocks >= 2 then
				grant_favors(1)
				return next_turn()
			elseif phase_just_completed == 3 and count_blocks >= 6 then
				grant_favors(3)
				return next_turn()
			elseif phase_just_completed == 3 and count_blocks >= 4 then
				grant_favors(2)
				return next_turn()
			elseif phase_just_completed == 3 and count_blocks >= 2 then
				grant_favors(1)
				return next_turn()
			end
			--check next player
			state.turn = state.turn + 1
		end
		return check_for_score_phase()
	else
		assert(false, string.format("don't know how to process next turn for this phase (%d)", state.phase))
	end
end

function next_building()
	assert(state.phase == PHASE_ACTIVATE_BUILDINGS)
	if state.active_building > 0 and state.buildings[state.active_building].delay_build then
		--the replaced building might go back to the supply
		local old_bldg = state.buildings[state.active_building].ref
		if old_bldg.btype == "wood" or old_bldg.btype == "stone" then
			update_unbuilt(old_bldg.id, 1)
		end

		--now handle the delayed building
		local bldg = state.buildings[state.active_building]
		bldg.ref = bldg.delay_build
		bldg.owner = bldg.delay_owner
		bldg.delay_build = nil
		bldg.delay_owner = nil
	end

	while state.active_building < #state.buildings do
		state.active_building = state.active_building + 1
		if state.active_building == BRIDGE_POSITION then
			clear_favor_used_status()
		end
		local can_activate = state.active_building <= state.provost or state.active_building == CASTLE_POSITION
		if state.active_building == BRIDGE_POSITION and not USE_PROVOST then
			can_activate = false
			state.buildings[BRIDGE_POSITION].occupants = {}
		end
		if can_activate and #state.buildings[state.active_building].occupants > 0 then
			if state.buildings[state.active_building].ref == STABLES then
				state.turn = TURN_BOARD_ACTION
				return
			else
				state.turn = 1
				return
			end
		elseif state.buildings[state.active_building].ref == INN and state.resident then
			state.turn = TURN_OWNER_ACTION
			return
		end
	end
	return end_of_activate_buildings_phase()
end

function end_of_worker_placement_phase()
	assert(state.phase == PHASE_WORKER_PLACEMENT)
	state.phase = state.phase + 1
	state.active_building = 0
	next_building()
end

function clear_favor_used_status()
	for i,player in ipairs(state.players) do
		player.vp_favor_used = false
		player.money_favor_used = false
		player.resource_favor_used = false
		player.build_favor_used = false
	end
end

function end_of_activate_buildings_phase()
	assert(state.phase == PHASE_ACTIVATE_BUILDINGS)
	assert(state.favors_left == 0)
	assert(not state.favors_active)
	state.phase = PHASE_CASTLE_FAVOR

	if state.best_contribution_player then
		clear_favor_used_status()
		grant_favors(1)
		return next_turn()
	else
		return end_of_castle_favor_phase()
	end
end

function end_of_castle_favor_phase()
	assert(state.phase == PHASE_CASTLE_FAVOR)
	assert(state.favors_left == 0)
	assert(not state.favors_active)
	state.best_contribution_amount = 0
	state.best_contribution_player = nil
	for i,bldg in ipairs(state.buildings) do
		bldg.occupants = {}
	end
	for name,player in pairs(state.players) do
		player.workers_left = state.resident == name and 5 or 6
		player.passed = false
	end
	if state.provost > state.bailiff then
		state.bailiff = state.bailiff + 2
	else
		state.bailiff = state.bailiff + 1
	end
	state.provost = state.bailiff
	state.active_building = 0

	-- check whether it's time to perform a scoring
	return check_for_score_phase()
end

--this function will either enter a scoring phase or start the next round
function check_for_score_phase()
	if state.phase == PHASE_SCORING then
		state.contribution_count = math.max(state.contribution_count, CASTLE_CONTRIBUTION_THRESHOLDS[state.castle_phase])
		state.castle_phase = state.castle_phase + 1
	end

	if state.castle_phase > 3 then
		return end_of_game()
	end

	if state.bailiff >= CASTLE_BAILIFF_THRESHOLDS[state.castle_phase]
			or state.contribution_count >= CASTLE_CONTRIBUTION_THRESHOLDS[state.castle_phase] then
		state.phase = PHASE_SCORING
		state.turn = 0
		clear_favor_used_status()
		return next_turn()
	else
		return end_of_scoring_phase()
	end
end

function end_of_scoring_phase()
	state.round = state.round + 1

	--if two-player game, swap the turn order
	if #state.order == 2 then
		local tmp = state.order[1]
		state.order[1] = state.order[2]
		state.order[2] = tmp
	end

	for name,player in pairs(state.players) do
		player.resources.money = player.resources.money + player.income
	end
	state.phase = PHASE_WORKER_PLACEMENT
	state.turn = 1
	clear_favor_used_status()

	assert(state.castle_phase <= 3)
end

function end_of_game()
	for i,player in pairs(state.players) do
		local ngold = player.resources.gold
		player.score = player.score + 3 * ngold
		player.resources.gold = 0

		local points_for_money = math.floor(player.resources.money / 4)
		player.score = player.score + points_for_money
		player.resources.money = player.resources.money - 4 * points_for_money

		local nresources = player.resources["food"]
			+ player.resources["wood"]
			+ player.resources["stone"]
			+ player.resources["cloth"]
		local points_for_resources = math.floor(nresources / 3)
		player.score = player.score + points_for_resources
		nresources = points_for_resources * 3
		for i,r in ipairs({"food","wood","stone","cloth"}) do
			while nresources > 0 and player.resources[r] > 0 do
				player.resources[r] = player.resources[r] - 1
				nresources = nresources - 1
			end
		end
	end
	state.phase = PHASE_END
	state.turn = 0
end

--perform board actions when stable is activated
function do_stables()
	local change_order =
		function(player_id, new_position)
			for j = 1,#state.order do
				if state.order[j] == player_id then
					table.remove(state.order, j)
					table.insert(state.order, new_position, player_id)
					return
				end
			end
		end
	for i,player_id in ipairs(state.buildings[state.active_building].occupants) do
		change_order(player_id, i)
	end
	state.buildings[state.active_building].occupants = {}

	describe_last_move = function()
		return string.format("Turn order is now %s",
			table.concat(map(function(x) return string.format("{p%d}", x) end, state.order), ", ")
			)
	end
end

function do_board_action()
	assert(state.turn == TURN_BOARD_ACTION)
	if state.phase == PHASE_ACTIVATE_BUILDINGS then
		if state.buildings[state.active_building].ref == STABLES then
			do_stables()
			
			return next_turn()
		end
	end
	assert(false, "can't do board action now")
end

function get_cost_to_place_worker(player_id, building)
	local num_players_passed = #state.buildings[BRIDGE_POSITION].occupants
	local cost =
		building.owner == player_id and 1 or
		state.resident == player_id and 1 or
		(#state.order == 2 and num_players_passed == 1) and 3 or
		(num_players_passed + 1)
	return cost
end

function do_move_place_worker(player_id, position)
	assert(state.phase == PHASE_WORKER_PLACEMENT, "wrong phase for this move")
	assert(player_id == current_turn(), "not that player's turn")
	local bldg = state.buildings[position]
	local player_struct = state.players[player_id]
	local cost = get_cost_to_place_worker(player_id, bldg)
	player_struct.resources.money = player_struct.resources.money - cost
	player_struct.workers_left = player_struct.workers_left - 1
	bldg:add_occupant(player_id)

	--give VP to owner of building, if owner exists and is not current player
	if bldg.owner and bldg.owner ~= player_id and bldg.ref ~= INN then
		state.players[bldg.owner].score = state.players[bldg.owner].score + 1
	end

	describe_last_move = function()
		return string.format("takes %s for %s",
				bldg.ref.name,
				cost_str_coins(cost)
			)
	end
end

function do_move_gate(position)
	assert(state.buildings[state.active_building].ref == GATE)
	local player_id = state.buildings[state.active_building]:remove_occupant(1)
	state.buildings[position]:add_occupant(player_id)
end

function get_player_by_id(player_id)
	--not quite right, but good enough for now perhaps
	return state.players[player_id];
end

function position_in_turn_order(player_id)
	for i=1,#state.order do
		if state.order[i] == player_id then
			return i
		end
	end
	assert(false, "player_id is not found in order[] array")
	return 0
end

function select_random_move()
	local moves = all_available_moves()
	assert(#moves > 0, "Error: no moves")

	local m = moves[math.random(#moves)]
	return m
end

function select_move()
	return PLAYERS_INFO[current_turn()].personality.select_move()
end

function get_pickup_choices()
	local moves = all_available_moves()
	return table.concat(moves, ";")
end

function get_building_choices(btype)

	local prefix = (state.favors_active or state.active_building == JOUST_POSITION) and "favor %w+" or "build"

	if btype == "auto" or not btype then
		local bldg = state.buildings[state.active_building]
		if bldg and bldg.ref
			and bldg.ref.is_builder
		then
			btype = bldg.ref.builder_type
		else
			return {}
		end
	end

	local templates =
		btype == "wood" and 
			WOOD_BUILDINGS
		or btype == "stone" and
			STONE_BUILDINGS
		or btype == "residence" and
			{ RESIDENCE }
		or btype == "prestige" and
			PRESTIGE_BUILDINGS
		or error("invalid btype " .. btype)

	local result = {}
	local result_by_id = {}
	for i,bldgref in ipairs(templates) do
		local bv1 = prefix == "build" and "build"
			or ("favor "..bldgref.btype)
		local xx = {
			tile_id = bldgref.tile_id,
			name = bldgref.name,
			description = bldgref.description,
			cost = bldgref.cost,
			reward = bldgref.reward,
			can_build = false,
			pay_options_t = {},
			loc_options_t = {},
			moveprefix = string.format("%s %s", bv1, bldgref.id),
			};
		if bldgref.reward_favor then
			xx.reward = string.format("%s,%dfavor",
				bldgref.reward,
				bldgref.reward_favor)
		end
		if is_unbuilt(bldgref.id) then
			table.insert(result, xx)
		end
		result_by_id[bldgref.id] = xx
	end

	if not caylus.is_end_of_game(state) then
	local moves = all_available_moves()
	for i,m in ipairs(moves) do
		local bid,pmt,pos = string.match(m, "^"..prefix.." ([%w-]+) ([^%s]+) (.+)")
		local bldgref = ALL_BUILDINGS[bid]
		if bldgref and bldgref.btype == btype and pos then
			local position = pos ~= "na" and tonumber(pos) or nil
			assert(result_by_id[bid], string.format("no %s building %s", btype, bid))
			result_by_id[bid].can_build = true
			result_by_id[bid].pay_options_t[pmt] = 1
			if position then
				result_by_id[bid].loc_options_t[position] = 1
			end
		end
	end
	end --if not end of game

	for i,r in ipairs(result) do
		r.pay_options = table.concat(keys(r.pay_options_t),";")
		r.loc_options = table.concat(keys(r.loc_options_t),";")
	end

	return result
end

function encode_rules()
	local rules_as_array = {}
	if not USE_FAVORS then
		table.insert(rules_as_array, "nofavors")
	end
	if not USE_PROVOST then
		table.insert(rules_as_array, "noprovost")
	end
	return table.concat(rules_as_array, ",")
end

function default_rules()
	USE_FAVORS = true
	USE_PROVOST = true
end

function decode_rules(rules_str)
	for r in rules_str:split(",") do
		if r == "nofavors" then
			USE_FAVORS = false
		elseif r == "noprovost" then
			USE_PROVOST = false
		end
	end
end

function serialize(tree)
	local buf = ""

	local function property(k,v)
		v = tostring(v)
		v = v:gsub("\\", "\\\\")
		v = v:gsub("]", "\\]")
		buf = buf .. string.format("%s[%s]", k, v)
	end

	local function helper(node)
		for k,v in pairs(node) do
			if string.match(k, "^[A-Z]") then
				property(k,v)
			end
		end
		if node.child and node.child.sibling then
			buf = buf .. "(;\n"
			helper(node.child)
			buf = buf .. ")"
		elseif node.child then
			buf = buf .. ";\n"
			helper(node.child)
		end
		if node.sibling then
			buf = buf .. ")(;\n"
			helper(node.sibling)
		end
	end

	helper(tree or game_tree)
	buf = buf .. "\n"

	return buf
end

function get_bldgref_by_id(string)
	if ALL_BUILDINGS[string] then
		return ALL_BUILDINGS[string]
	end

	error("unrecognized building: "..string)
end

function decode_building(position, string)
	state.buildings[position].ref = get_bldgref_by_id(string)
end

function decode_buildings(p)
	for position = BRIDGE_POSITION + 1, LAST_EMPTY_POSITION do
		local building_str = p[string.format("Building%d",position)]
		if building_str then
			decode_building(position, building_str)
		end
	end
end

function decode_order(order_string)
	state.order = {}
	for v in order_string:split(",") do
		table.insert(state.order, tonumber(v))
	end
end

function decode_player_info(p)
	for idx,pi in pairs(PLAYERS_INFO) do
		local n = p[string.format("P%d",idx)]
		if n then
			pi.name = n
		end

		n = p[string.format("Color%d",idx)]
		if n then
			pi.color = n
		end

		n = p[string.format("Bot%d",idx)]
		if n then
			pi.ai_path = n
		end
	end
end

local function decode_player_stock(p)
	local function decode_helper(player_struct,prop)
		local array = {}
		for k in prop:split(",") do table.insert(array,tonumber(k)) end
		player_struct.score = array[1]
		player_struct.resources.money = array[2]
		player_struct.resources.food = array[3]
		player_struct.resources.wood = array[4]
		player_struct.resources.stone = array[5]
		player_struct.resources.cloth = array[6]
		player_struct.resources.gold = array[7]
	end

	for idx,player_struct in pairs(state.players) do
		local tmp = p[string.format("Stock%d",idx)]
		if tmp then
			decode_helper(player_struct,tmp)
		end
	end
end

function deserialize(buf)
	local did_init = false
	local root = {}
	local p = root
	local function handle_new_node()
		local new_node = { parent = p }
		if p.child then
			p = p.child
			while p.sibling do
				p = p.sibling
			end
			p.sibling = new_node
		else
			p.child = new_node
		end
		p = new_node
	end
	local function handle_prop_value(prop_name, prop_value)
		p[prop_name] = prop_value
	end
	local parents_stack = {}
	local function handle_token(token)
		if token == ";" then
			handle_new_node()
		elseif token == "(" then
			table.insert(parents_stack, p)
		elseif token == ")" then
			p = table.remove(parents_stack)
		else
			--ignore for now
		end
	end
	local function handle_bad_token(text)
		error(string.format(
			"invalid string in input (%d): \"%s\"",
			string.len(text),
			text))
	end

	local parser = {
		cur_word = 1,
		cur_prop_name = nil,
		is_escaped = false,
		}
	for i = 1,string.len(buf) do
		local c = string.sub(buf, i, i)
		if parser.is_escaped then
			parser.is_escaped = false
		elseif c == "\\" then
			parser.is_escaped = true
		elseif c == "[" and not parser.cur_prop_name then
			parser.cur_prop_name = string.sub(buf, parser.cur_word, i-1)
			parser.cur_word = i + 1
		elseif c == "]" and parser.cur_prop_name then
			handle_prop_value(
					parser.cur_prop_name,
					string.sub(buf, parser.cur_word, i-1))
			parser.cur_word = i + 1
			parser.cur_prop_name = nil
		elseif not parser.cur_prop_name and (c == ";" or c == "(" or c == ")") then
			if parser.cur_word ~= i then
				handle_bad_token(string.sub(buf, parser.cur_word, i-1))
			end
			handle_token(c)
			parser.cur_word = i + 1
		elseif c == " " or c == "\t" or c == "\n" or c == "\r" then
			if parser.cur_word == i then
				parser.cur_word = i + 1
			end
		end
	end
	game_tree = root
	current_node = p
	reload_state(p)
	current_node.state = state
end

function apply_node_properties(node)
	if node.PlayerCount or node.Seed or not state then
		default_rules()
		state_init(node.PlayerCount, node.Seed)
	end
	if node.M then
		do_move(node.M)
	end
	if node.Rules then
		decode_rules(node.Rules)
	end
	decode_buildings(node)
	decode_player_info(node)
	if node.Order then
		decode_order(node.Order)
		if node.PlayerCount then
			init_player_money()
		end
	end
	decode_player_stock(node)
	--Note: we ignore unrecognized properties
end

function reload_state(node)
	if node.parent then
		reload_state(node.parent)
	else
		state = nil
	end

	apply_node_properties(node)
end

function caylus.is_end_of_game(in_state)
	return in_state.castle_phase > 3
end

if random then
	local RANDOM_GENERATOR = random.new()
	function math.randomseed(s)
		return RANDOM_GENERATOR:seed(s)
	end
	function math.random(...)
		return RANDOM_GENERATOR:value(...)
	end
end

function next_move()
	assert(current_node.child, "No next moves")
	if current_node.state then
		state = current_node.state
		current_node.state = nil
		current_node = current_node.child
		apply_node_properties(current_node)
		current_node.state = state
	else
		current_node.state = nil
		current_node = current_node.child
		reload_state(current_node)
		current_node.state = state
	end
end

function previous_move()
	assert(current_node.parent, "No previous moves")
	assert(current_node.parent ~= game_tree, "Already at first move")

	current_node.state = nil
	current_node = current_node.parent
	reload_state(current_node)
	current_node.state = state
end

function is_edit_node(node)
	return not (
		node.M or node.M1 or node.M2 or node.M3
		or node.M4 or node.M5
		)
end

function refresh_game_properties()
	local function get_implicit_property(node, property_name)
		if node.parent then
			if node.parent[property_name] then
				return node.parent[property_name]
			else
				return get_implicit_property(node.parent, property_name)
			end
		else
			return nil
		end
	end

	local my_setup_node = current_node
	while my_setup_node.parent and not is_edit_node(my_setup_node) do
		my_setup_node = my_setup_node.parent
	end

	local function refresh_property(property_name, value)
		local existing_value = get_implicit_property(my_setup_node, property_name)
		if existing_value == value then
			my_setup_node[property_name] = nil
		else
			my_setup_node[property_name] = value
		end
	end

	for pid in pairs(state.players) do
		assert(PLAYERS_INFO[pid])
		refresh_property(string.format("P%d",pid), PLAYERS_INFO[pid].name)
		refresh_property(string.format("Color%d",pid), PLAYERS_INFO[pid].color)
		refresh_property(string.format("Bot%d",pid), PLAYERS_INFO[pid].ai_path and "" or nil)
	end
end

function get_path_to_node(cur)
	local list = {}
	local count_first_childs = 0
	while cur.parent do
		local tmp = cur.parent.child
		local child_no = 1
		while assert(tmp) and tmp ~= cur do
			child_no = child_no + 1
			tmp = tmp.sibling
		end
		if child_no == 1 then
			count_first_childs = count_first_childs + 1
		elseif count_first_childs > 0 then
			table.insert(list, "~"..count_first_childs)
			count_first_childs = 0
			table.insert(list, ":"..child_no)
		else
			table.insert(list, ":"..child_no)
		end
		cur = cur.parent
	end
	if count_first_childs > 0 then
		table.insert(list, "~"..count_first_childs)
	end

	assert(cur == game_tree)
	local reversed = {}
	while #list > 0 do
		local el = table.remove(list)
		table.insert(reversed, el)
	end
	return table.concat(reversed, "")
end

function get_path_to_current_node()
	return get_path_to_node(current_node)
end

function set_current_node(node)

	if current_node then
		current_node.state = nil
	end

	current_node = node
	reload_state(node)
	current_node.state = state
end

--makes the current node the first child of the parent node
function promote_current_node()

	local parent = current_node.parent
	if parent.child == current_node then
		return
	end

	local n = parent.child
	while n do
		if n.sibling == current_node then
			n.sibling = current_node.sibling
		end
		n = n.sibling
	end

	current_node.sibling = parent.child
	parent.child = current_node
end

function get_node_from_path(pathstr)

	local cur = game_tree
	local start = 1
	local len = pathstr:len()

	--this little helper function constructs an error message in case
	--we have trouble following the given path; the error message
	--indicates where in the path we had trouble, which might help
	--the user figure out what the problem is.
	local function error_str_func(x0, x1)
		return "path not found at "
			.. pathstr:sub(1,x0-1)
			.. "{" .. pathstr:sub(x0,x1)
			.. "}" .. pathstr:sub(x1+1)
	end

	while start <= len do
		local pat1a, pat1b = pathstr:find(":%d+", start)
		local pat2a, pat2b = pathstr:find("~%d+", start)
		if pat1a == start then
			--take nth child
			local n = tonumber(pathstr:sub(pat1a+1,pat1b))
			cur = cur.child
			assert(cur, error_str_func(pat1a,pat1b))
			while n > 1 do
				cur = cur.sibling
				assert(cur, error_str_func(pat1a,pat1b))
				n = n - 1
			end
			start = pat1b + 1
		else
			--take first child n times
			local n = tonumber(pathstr:sub(pat2a+1,pat2b))
			while n > 0 do
				cur = cur.child
				assert(cur, error_str_func(pat2a,pat2b))
				n = n - 1
			end
			start = pat2b + 1
		end
	end

	return cur
end

function set_current_node_by_path(pathstr)

	set_current_node(get_node_from_path(pathstr))
end

function annotate_move(annotation)
	current_node.BM = (annotation == "bad" and "1" or nil)
	current_node.DO = (annotation == "doubtful" and "" or nil)
	current_node.IT = (annotation == "interesting" and "" or nil)
	current_node.TE = (annotation == "good" and "1" or nil)
end
